package com.engine.jucailinkq.attendance.attendanceanalysis.dto.clockpoint;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

/**
 * 卡点相关信息类
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ClockPointInfo {
    /**
     * 分析日期
     */
    private String analysisDate;
    /**
     * 卡点集合
     */
    private List<ClockPointDTO> clcokInPointList;
    /**
     * 班次集合
     */
    private List<Map<String, Object>> scheduleResult;
    /**
     * 请假以及出差班次集合
     */
    private List<Map<String, Object>> askForLeaveAndEvctionScheduleList;
    /**
     * 打卡数据
     */
    List<Map<String, Object>> clockInTimeList;
}
