package com.engine.jucailinkq.attendance.workflow.action;

import com.engine.jucailinkq.common.util.DbTools;
import lombok.extern.slf4j.Slf4j;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 出差流程退回
 */
@Slf4j
public class EvectionBackAction implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        String requestId = requestInfo.getRequestid();
        try {
            String sql = "select id from uf_jcl_kq_ccjl where djly = 0 and lyid = " + requestId;
            List<Map<String, Object>> ccData = DbTools.getSqlToList(sql);
            if (ccData.size() > 0) {
                List<String> ccjlIdList = ccData.stream().map(f->f.get("id").toString()).collect(Collectors.toList());
                //删除出差记录明细表
                sql = "delete from uf_jcl_kq_ccjl_dt1 where mainid in (" + String.join(",", ccjlIdList) + ")";
                boolean delSign1 = DbTools.update(sql);
                String message = "";
                if (!delSign1) {
                    message = message + "删除出差记录明细表数据失败！";
                }
                //删除出差记录主表
                sql = "delete from uf_jcl_kq_ccjl where id in (" + String.join(",", ccjlIdList) + ")";
                boolean delSign2 = DbTools.update(sql);
                if (!delSign2) {
                    message = message + "删除出差记录主表数据失败！";
                }
                if (!delSign1 || !delSign2) {
                    log.error(message);
                    requestInfo.getRequestManager().setMessageid("11111" + requestInfo.getRequestid() + "22222");
                    requestInfo.getRequestManager().setMessagecontent(message);
                    return Action.FAILURE_AND_CONTINUE;
                }
            }
        }catch (Exception e){
            log.error("EvctionBackAction error : [{}]", e.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }
}
