package com.engine.jucailinkq.attendance.attendanceplan.service;

import java.util.Map;

public interface AttendancePlanService {
    /**
     * 根据人员获得考勤项目
     * @param params
     * @return
     */
    Map<String,Object> getAttendanceItemsByPerson(Map<String,Object> params);

    /**
     * 根据人员获得综合工时
     * @param params
     * @return
     */
    Map<String,Object> getWorkHoursItemByPerson(Map<String,Object> params);

    /**
     * 获得根据考勤方案分组的考勤项目
     * @return
     */
    Map<String,Object> getAttendanceItemsGroupByAttendancePlanDataCmd();

}
