package com.engine.jucailinkq.attendance.workflow.action;

import com.engine.jucailinkq.common.util.DbTools;
import lombok.extern.slf4j.Slf4j;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 补打卡退回action
 */
@Slf4j
public class MakeUpClockInBackAction implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {

        String requestId = requestInfo.getRequestid();
        try {
            String sql = "select id from uf_jcl_kq_bdkjl where sjly = 0 and lcid = " + requestId;
            List<Map<String, Object>> bdkData = DbTools.getSqlToList(sql);
            if (bdkData.size() > 0) {
                List<String> bdkjlIdList = bdkData.stream().map(f->f.get("id").toString()).collect(Collectors.toList());
                //删除出差记录主表
                sql = "delete from uf_jcl_kq_bdkjl where id in (" + String.join(",", bdkjlIdList) + ")";
                boolean delSign = DbTools.update(sql);
                String message = "";
                if (!delSign) {
                    message = message + "删除补打卡记录表数据失败！";
                    log.error(message);
                    requestInfo.getRequestManager().setMessageid("11111" + requestInfo.getRequestid() + "22222");
                    requestInfo.getRequestManager().setMessagecontent(message);
                    return Action.FAILURE_AND_CONTINUE;
                }
            }
        }catch (Exception e){
            log.error("MakeUpClockInBackAction : [{}]", e.getMessage());
        }
        return Action.SUCCESS;
    }



}
